<?php
/*
 * Plugin Name: WP e-Commerce Analytics
 * Version: 0.1.3
 * Plugin URI: http://www.visser.com.au/wordpress/
 * Description: Adds transaction tracking to Google Analytics
 * Author: Visser Labs
 * Author URI: http://www.visser.com.au/
 */

/*
 This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.

 This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 */

function wpec_transaction_tracking () {

	global $wpdb, $sessionid;

	if(!$sessionid)
		return;
	
	$purchase_log = $wpdb->get_results ("SELECT *
	                                       FROM `".WPSC_TABLE_PURCHASE_LOGS."`
	                                      WHERE `sessionid` = '".$sessionid."'", ARRAY_A);

	$purchase_log = $purchase_log[0];
	$purchase_log_id = $purchase_log['id'];

	$purchase_log_data_city = $wpdb->get_var ("SELECT `".WPSC_TABLE_SUBMITED_FORM_DATA."`.`value`
	                                             FROM `".WPSC_TABLE_SUBMITED_FORM_DATA."`
	                                        LEFT JOIN `".WPSC_TABLE_CHECKOUT_FORMS."`
	                                               ON `".WPSC_TABLE_CHECKOUT_FORMS."`.`id` = `".WPSC_TABLE_SUBMITED_FORM_DATA."`.`form_id`
	                                            WHERE `".WPSC_TABLE_CHECKOUT_FORMS."`.`type` = 'city'
	                                              AND log_id = '$purchase_log_id'" );

	$purchase_log_data_country = $wpdb->get_var ("SELECT `".WPSC_TABLE_SUBMITED_FORM_DATA."`.`value`
	                                                FROM `".WPSC_TABLE_SUBMITED_FORM_DATA."`
	                                           LEFT JOIN `".WPSC_TABLE_CHECKOUT_FORMS."`
	                                                  ON `".WPSC_TABLE_CHECKOUT_FORMS."`.`id` = `".WPSC_TABLE_SUBMITED_FORM_DATA."`.`form_id`
	                                               WHERE `".WPSC_TABLE_CHECKOUT_FORMS."`.`type` = 'country'
	                                                 AND log_id = '$purchase_log_id'" );

	$cart_item_shipping = $wpdb->get_var ("SELECT SUM(qty*pnp) as pnp,
	                                              SUM(tax_charged) as tax,
	                                         FROM `".WPSC_TABLE_CART_CONTENTS."`
	                                        WHERE purchaseid = '$purchase_log_id'");

	$total_shipping = $cart_item_shipping[0]['pnp'] + $purchase_log['base_shipping'];
	$total_tax = $cart_item_shipping[0]['tax'];

?>
<script type="text/javascript">
	try {
		pageTracker._addTrans(
			"<?php echo $purchase_log_id; ?>",
			"<?php echo get_bloginfo('name'); ?>",
			"<?php echo nzshpcrt_currency_display($purchase_log['totalprice'],1,true,false,true); ?>",
			"0.00",
			"<?php echo nzshpcrt_currency_display($total_shipping,1,true,false,true); ?>",
			"<?php echo $purchase_log_data_city; ?>",
			"",
			"<?php echo $purchase_log_data_country; ?>"
		);

<?php
	$purchase_log_data_items = $wpdb->get_results( "SELECT *
	                                                  FROM `".WPSC_TABLE_CART_CONTENTS."`
	                                                 WHERE purchaseid = $purchase_log_id", ARRAY_A);

	foreach( $purchase_log_data_items as $purchase_log_data_item ) {

		$purchase_log_data_item_sku_sql = "SELECT meta_value
		                                     FROM `".WPSC_TABLE_PRODUCTMETA."`
		                                    WHERE meta_key = 'sku'
		                                      AND product_id = '".$purchase_log_data_item['prodid']."'
		                                    LIMIT 1";
		$purchase_log_data_item['sku'] = $wpdb->get_var( $purchase_log_data_item_sku_sql );
		if (!isset($purchase_log_data_item['sku']) || $purchase_log_data_item['sku'] = '') {
			$purchase_log_data_item['sku'] = $purchase_log_data_item['prodid'];
		}

		$purchase_log_data_item_category_sql = "SELECT `".WPSC_TABLE_PRODUCT_CATEGORIES."`.`name`
		                                          FROM `".WPSC_TABLE_PRODUCT_CATEGORIES."`
		                                     LEFT JOIN `".WPSC_TABLE_ITEM_CATEGORY_ASSOC."`
		                                            ON `".WPSC_TABLE_PRODUCT_CATEGORIES."`.`id` = `".WPSC_TABLE_ITEM_CATEGORY_ASSOC."`.`category_id`
		                                         WHERE `".WPSC_TABLE_PRODUCT_CATEGORIES."`.`group_id` = '1'
		                                           AND `".WPSC_TABLE_ITEM_CATEGORY_ASSOC."`.`product_id` = '".$purchase_log_data_item['prodid']."'";
		$purchase_log_data_item['category'] = $wpdb->get_var( $purchase_log_data_item_category_sql );
?>
	pageTracker._addItem(
		"<?php echo $purchase_log_id; ?>",
		"<?php echo $purchase_log_data_item['sku']; ?>",
		"<?php echo $purchase_log_data_item['name']; ?>",
		"<?php echo $purchase_log_data_item['category']; ?>",
		"<?php echo $purchase_log_data_item['price']; ?>",
		"<?php echo $purchase_log_data_item['quantity']; ?>"
	);
<?php
	}
?>
	pageTracker._trackTrans();
	} catch(err) {}</script>

<?php
}

add_action('wp_footer', 'wpec_transaction_tracking');

?>
